/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "github.com/longhorn/longhorn-manager/k8s/pkg/apis/longhorn/v1beta2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// ShareManagerLister helps list ShareManagers.
type ShareManagerLister interface {
	// List lists all ShareManagers in the indexer.
	List(selector labels.Selector) (ret []*v1beta2.ShareManager, err error)
	// ShareManagers returns an object that can list and get ShareManagers.
	ShareManagers(namespace string) ShareManagerNamespaceLister
	ShareManagerListerExpansion
}

// shareManagerLister implements the ShareManagerLister interface.
type shareManagerLister struct {
	indexer cache.Indexer
}

// NewShareManagerLister returns a new ShareManagerLister.
func NewShareManagerLister(indexer cache.Indexer) ShareManagerLister {
	return &shareManagerLister{indexer: indexer}
}

// List lists all ShareManagers in the indexer.
func (s *shareManagerLister) List(selector labels.Selector) (ret []*v1beta2.ShareManager, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.ShareManager))
	})
	return ret, err
}

// ShareManagers returns an object that can list and get ShareManagers.
func (s *shareManagerLister) ShareManagers(namespace string) ShareManagerNamespaceLister {
	return shareManagerNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// ShareManagerNamespaceLister helps list and get ShareManagers.
type ShareManagerNamespaceLister interface {
	// List lists all ShareManagers in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1beta2.ShareManager, err error)
	// Get retrieves the ShareManager from the indexer for a given namespace and name.
	Get(name string) (*v1beta2.ShareManager, error)
	ShareManagerNamespaceListerExpansion
}

// shareManagerNamespaceLister implements the ShareManagerNamespaceLister
// interface.
type shareManagerNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all ShareManagers in the indexer for a given namespace.
func (s shareManagerNamespaceLister) List(selector labels.Selector) (ret []*v1beta2.ShareManager, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.ShareManager))
	})
	return ret, err
}

// Get retrieves the ShareManager from the indexer for a given namespace and name.
func (s shareManagerNamespaceLister) Get(name string) (*v1beta2.ShareManager, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta2.Resource("sharemanager"), name)
	}
	return obj.(*v1beta2.ShareManager), nil
}
